typo in backupninja.1
[matthijs/upstream/backupninja.git] / handlers / mysql
index 277a34553bbf24fb70d4dcfcfd4cf8db5bd918ef..de4e4c3d2f920d8117c2e960e9c1f5e1619ccf22 100644 (file)
@@ -1,4 +1,4 @@
-# -*- mode: sh; sh-basic-offset: 8; indent-tabs-mode: nil; -*-
+# -*- mode: sh; sh-basic-offset: 3; indent-tabs-mode: nil; -*-
 #
 # mysql handler script for backupninja
 #
@@ -19,33 +19,28 @@ getconf dbpassword
 getconf configfile /etc/mysql/debian.cnf
 
 
-# If vservers are configured, decide if the handler should
-# use them or if it should just operate on the host
-
-if [ "$vservers" = "yes" ]
-then
-       if [ ! -z $vsname ]
-       then            
-               info "Using vserver '$vsname'"
-               usevserver=1
-       else
-               info "No vserver name specified, actions will be performed on the host"
-       fi
-fi
-
-# If needed, make sure that the specified vserver exists and is running.
-if [ $usevserver ]
-then
-       debug "Examining vserver '$vsname'"
-       # does it exist ?
-       vroot="$VROOTDIR/$vsname"
-       [ -d $vroot ] || fatal "vserver '$vsname' does not exist at '$vroot'"
-       # is it running ?
-       $VSERVERINFO -q $vsname RUNNING
-       if [ $? -ne 0 ]
-       then
-               fatal "vserver $vsname is not running."
-       fi
+# Decide if the handler should operate on a vserver or on the host.
+# In the former case, check that $vsname exists and is running.
+local usevserver=no
+local vroot
+if [ $vservers_are_available = yes ]; then
+   if [ -n "$vsname" ]; then
+      # does it exist ?
+      if ! vservers_exist "$vsname" ; then
+         fatal "The vserver given in vsname ($vsname) does not exist."
+      fi
+      # is it running ?
+      $VSERVERINFO -q $vsname RUNNING
+      if [ $? -ne 0 ]; then
+         fatal "The vserver $vsname is not running."
+      fi
+      # everything ok
+      info "Using vserver '$vsname'."
+      usevserver=yes
+      vroot="$VROOTDIR/$vsname"
+   else
+      info "No vserver name specified, actions will be performed on the host."
+   fi
 fi
 
 ## Prepare ignore part of the command
@@ -63,7 +58,7 @@ done
 hotdir="$backupdir/hotcopy"
 dumpdir="$backupdir/sqldump"
 
-if [ $usevserver ]
+if [ $usevserver = yes ]
 then
        [ "$sqldump" == "no" -o -d $vroot$dumpdir ] || $VSERVER $vsname exec mkdir -p $dumpdir
        [ "$hotcopy" == "no" -o -d $vroot$hotdir ] || $VSERVER $vsname exec mkdir -p $hotdir
@@ -80,7 +75,7 @@ fi
 # 1. setting the user, so that /home/user/.my.cnf is used.
 # 2. specifying the user and password in the handler config,
 #    which generates a temporary .my.cnf in /root/.my.cnf
-# 3. specify the config file with --defaults-file
+# 3. specify the config file with --defaults-extra-file
 #    (this option DOESN'T WORK WITH MYSQLHOTCOPY)
 #
 
@@ -93,12 +88,12 @@ defaultsfile=""
 
 if [ "$dbusername" != "" -a "$dbpassword" != "" ]
 then
-    if [ $usevserver ]
+    if [ $usevserver = yes ]
     then
-       vhome=`$VSERVER $vsname exec getent passwd "root" | awk -F: '{print $6}'`
+       vhome=`$VSERVER $vsname exec getent passwd "root" | @AWK@ -F: '{print $6}'`
        home="$vroot$vhome"
     else
-       home=`getent passwd "root" | awk -F: '{print $6}'`
+       home=`getent passwd "root" | @AWK@ -F: '{print $6}'`
     fi
 
     [ -d $home ] || fatal "Can't find root's home directory ($home)."
@@ -133,33 +128,30 @@ user=$dbusername
 password="$dbpassword"
 EOF
        umask $oldmask
-       if [ $usevserver ] 
+       if [ $usevserver = yes 
        then
-           defaultsfile="--defaults-file=$vhome/.my.cnf"
+           defaultsfile="--defaults-extra-file=$vhome/.my.cnf"
        else
-           defaultsfile="--defaults-file=$mycnf"
+           defaultsfile="--defaults-extra-file=$mycnf"
        fi
-       
-# if user is set, don't use $mycnf     
-elif [ "$userset" == "false" ]; then
-               defaultsfile="--defaults-file=$configfile"
 fi
 
+# if a user is not set, use $configfile, otherwise use $mycnf
 if [ "$user" == "" ]; then
-       userset=false;
        user=root;
+       defaultsfile="--defaults-extra-file=$configfile"
 else
        userset=true;
-       if [ $usevserver ]
+       if [ $usevserver = yes ]
        then
-           vuserhome=`$VSERVER $vsname exec getent passwd "$user" | awk -F: '{print $6}'`
+           vuserhome=`$VSERVER $vsname exec getent passwd "$user" | @AWK@ -F: '{print $6}'`
            if [ $? -eq 2 ]
            then
                fatal "User $user not found in /etc/passwd"
            fi
            userhome="$vroot$vuserhome"
        else
-           userhome=`getent passwd "$user" | awk -F: '{print $6}'`
+           userhome=`getent passwd "$user" | @AWK@ -F: '{print $6}'`
            if [ $? -eq 2 ]
            then
                fatal "User $user not found in /etc/passwd"
@@ -168,7 +160,7 @@ else
        
        debug "User home set to: $userhome"
        [ -f $userhome/.my.cnf ] || fatal "Can't find config file in $userhome/.my.cnf"
-       defaultsfile="--defaults-file=$vuserhome/.my.cnf"
+       defaultsfile="--defaults-extra-file=$userhome/.my.cnf"
        debug "using $defaultsfile"
 fi
 
@@ -180,14 +172,14 @@ then
     info "Initializing hotcopy method"
     if [ "$databases" == "all" ]
     then
-       if [ $usevserver ]
+       if [ $usevserver = yes ]
        then
                info "dbhost: $dbhost"
                execstr="$VSERVER $vsname exec $MYSQLHOTCOPY -h $dbhost --quiet --allowold --regexp /.\*/./.\*/ $hotdir"
        else
                execstr="$MYSQLHOTCOPY --quiet --allowold --regexp /.\*/./.\*/ $hotdir"
        fi
-       debug "su $user -c '$execstr'"
+       debug "su $user -c \"$execstr\""
        if [ ! $test ]
        then
                output=`su $user -c "$execstr" 2>&1`
@@ -204,13 +196,13 @@ then
     else       
        for db in $databases
        do
-               if [ $usevserver ]
+               if [ $usevserver = yes ]
                then
                        execstr="$VSERVER $vsname exec $MYSQLHOTCOPY --allowold $db $hotdir"
                else
                        execstr="$MYSQLHOTCOPY --allowold $db $hotdir"
                fi
-               debug "su $user -c '$execstr'"
+               debug 'su $user -c \"$execstr\"'
                if [ ! $test ]
                then
                        output=`su $user -c "$execstr" 2>&1`
@@ -236,31 +228,50 @@ then
     info "Initializing SQL dump method"
     if [ "$databases" == "all" ]
     then
-       if [ $usevserver ]
+       if [ $usevserver = yes ]
        then
+           debug 'echo show databases | $VSERVER $vsname exec su $user -c \"$MYSQL $defaultsfile\" | grep -v Database'
            databases=`echo 'show databases' | $VSERVER $vsname exec su $user -c "$MYSQL $defaultsfile" | grep -v Database`
            if [ $? -ne 0 ]
            then
-               fatal "Authentication problem, maybe user/password is wrong"
+               fatal "Authentication problem, maybe user/password is wrong or mysqld is not running?"
            fi
        else
                databases=`echo 'show databases' | su $user -c "$MYSQL $defaultsfile" | grep -v Database`
                if [ $? -ne 0 ]
                then
-                   fatal "Authentication problem, maybe user/password is wrong"
+                   fatal "Authentication problem, maybe user/password is wrong or mysqld is not running?"
                fi
        fi
 fi
 
        for db in $databases
        do
-               if [ $usevserver ]
+               if [ $usevserver = yes ]
                then
-                       execstr="$VSERVER $vsname exec $MYSQLDUMP $defaultsfile --lock-tables --complete-insert --add-drop-table --quick --quote-names $ignore $db > $vroot$dumpdir/${db}.sql"
+                   # Test to make sure mysqld is running, if it is not sqldump will not work
+                   $VSERVER $vsname exec su $user -c "$MYSQLADMIN $defaultsfile ping"
+                   if [ $? -ne 0 ]; then
+                      fatal "Either you have an authentication problem, or mysqld doesn't appear to be running!"
+                   fi
+                   if [ "$compress" == "yes" ]; then
+                      execstr="$VSERVER $vsname exec $MYSQLDUMP $defaultsfile --lock-tables --complete-insert --add-drop-table --quick --quote-names $ignore $db | $GZIP > $vroot$dumpdir/${db}.sql.gz"
+                   else
+                      execstr="$VSERVER $vsname exec $MYSQLDUMP $defaultsfile --lock-tables --complete-insert --add-drop-table --quick --quote-names $ignore $db -r $vroot$dumpdir/${db}.sql"
+                   fi
                else
-                       execstr="$MYSQLDUMP $defaultsfile --lock-tables --complete-insert --add-drop-table --quick --quote-names $ignore $db > $dumpdir/${db}.sql"
+                   # Test to make sure mysqld is running, if it is not sqldump will not work
+                   su $user -c "$MYSQLADMIN $defaultsfile ping"
+                   if [ $? -ne 0 ]; then
+                      fatal "Either you have an authentication problem, or mysqld doesn't appear to be running!"
+                   fi
+                   if [ "$compress" == "yes" ]; then
+                      execstr="$MYSQLDUMP $defaultsfile --lock-tables --complete-insert --add-drop-table --quick --quote-names $ignore $db | $GZIP > $dumpdir/${db}.sql.gz"
+                   else
+                      execstr="$MYSQLDUMP $defaultsfile --lock-tables --complete-insert --add-drop-table --quick --quote-names $ignore $db -r $dumpdir/${db}.sql"
+                   fi
                fi
-               debug "su $user -c '$execstr'"
+               debug "su $user -c \"$execstr\""
                if [ ! $test ]
                then
                        output=`su $user -c "$execstr" 2>&1`
@@ -275,16 +286,10 @@ fi
                        fi
                fi
        done
-       
-       if [ "$compress" == "yes" ]
-       then
-               output=`$GZIP -f $vroot$dumpdir/*.sql 2>&1`
-               debug $output
-       fi
 fi
 
 # clean up tmp config file
-if [ "$dbusername" != "" ]
+if [ "$dbusername" != "" -a "$dbpassword" != "" ]
 then
        ## clean up tmp config file
        debug "rm $mycnf"